services:
  traefik:
    container_name: traefik
    image: traefik:v3.0
    restart: unless-stopped
    network_mode: host
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock
      - traefik_letsencrypt:/letsencrypt
      - ${PWD}/http_passwd:/http_passwd
    command:
      - --api.dashboard=true
      - --api.insecure=${TRAEFIK_API_INSECURE:-false}
      - --providers.docker=true
      - --providers.docker.exposedbydefault=false
      - --entrypoints.web.address=:80
      - --entryPoints.web.http.redirections.entryPoint.to=websecure
      - --entryPoints.web.http.redirections.entryPoint.scheme=https
      - --entryPoints.websecure.address=:443
      - --entryPoints.websecure.asDefault=true
      - --certificatesresolvers.letsencrypt.acme.email=${ACME_EMAIL}
      - --certificatesresolvers.letsencrypt.acme.storage=/letsencrypt/acme.json
      - --certificatesresolvers.letsencrypt.acme.dnschallenge=true
      - --certificatesresolvers.letsencrypt.acme.dnschallenge.provider=regru
      - --certificatesResolvers.letsencrypt.acme.dnsChallenge.resolvers=ns1.reg.ru:53,ns2.reg.ru:53
      - --certificatesresolvers.letsencrypt.acme.dnschallenge.delaybeforecheck=300
      - --metrics.prometheus=true
      - --entryPoints.metrics.address=:9082
      - --metrics.prometheus.entryPoint=metrics
      - --log.level=${TRAEFIK_LOG_LEVEL:-INFO}
    environment:
      REGRU_USERNAME: ${REGRU_USERNAME}
      REGRU_PASSWORD: ${REGRU_PASSWORD}

  node-exporter:
    image: prom/node-exporter:v1.8.0
    container_name: node_exporter
    # для дашборда в графане
    hostname: dev_node_exporter
    ports:
      - 9100:9100
    volumes:
      - /proc:/host/proc:ro
      - /sys:/host/sys:ro
      - /:/rootfs:ro
    command:
      - --path.procfs=/host/proc
      - --path.sysfs=/host/sys
      - --collector.filesystem.ignored-mount-points
      - ^/(sys|proc|dev|host|etc)($$|/)
    restart: always

  cadvisor:
    image: gcr.io/cadvisor/cadvisor:v0.49.1
    container_name: cadvisor
    restart: always
    ports:
      - 9080:8080
    volumes:
      - /:/rootfs:ro
      - /var/run:/var/run:rw
      - /sys:/sys:ro
      - /var/lib/docker/:/var/lib/docker:ro
    command:
      - --storage_duration=15m0s
      - --housekeeping_interval=60s
      - --docker_only=true
      # - --store_container_labels=false
      # - --enable_metrics=cpu,memory,network
    labels:
      traefik.enable: true
      traefik.http.routers.cadvisor.rule: Host(`cadvisor.${TRAEFIK_TLS_DOMAIN_BASE}`)
      traefik.http.routers.cadvisor.tls: true
      traefik.http.routers.cadvisor.tls.certresolver: letsencrypt
      traefik.http.routers.cadvisor.tls.domains[0].main: ${TRAEFIK_TLS_DOMAIN_BASE}
      traefik.http.routers.cadvisor.tls.domains[0].sans: "*.${TRAEFIK_TLS_DOMAIN_BASE}"
      traefik.http.routers.cadvisor.middlewares: authtraefik
      traefik.http.middlewares.authtraefik.basicauth.usersfile: /http_passwd

volumes:
  traefik_letsencrypt: {}
